=begin
 /****************************************************************
**
** Implementation CannonField class, Qt tutorial 8
**
****************************************************************/
=end
# For rubyQt
require "qt"
include Qt

class CannonField < QWidget
def initialize(parent=nil,name="")
   @angleChanged = RSignal.new  # signal with int
   @ang = 45
   ef = QREventFilter.new(self)
   self.installEventFilter(ef)
end

def angleChanged
   @angleChanged
end

def setAngle degrees #slot
   if degrees < 5
      degrees = 5
   elsif degree > 70
      degrees = 70
   elsif degrees==ang
      return
   end
   ang = degrees
   self.paintEvent( QPaintEvent.new )
   angleChanged.send_int(ang)
end

def paintEvent ev
   str = "Angle = #{@ang}"
   drawText(200,200,str)
end

end