=begin
 /****************************************************************
**
** Implementation CannonField class, Qt tutorial 8
**
****************************************************************/
=end
# For rubyQt
require "qt"
include Qt

class CannonField < QWidget
def initialize(parent=nil,name="")
   @angleChanged = RSignal.new("int")  # signal with int
   @ang = 45
   catchEvent
end

def angleChanged
   @angleChanged
end

def setAngle degrees #slot
   if degrees < 5
      degrees = 5
   elsif degrees > 70
      degrees = 70
   elsif degrees == @ang
      return
   end
   @ang = degrees
   self.paintEvent(nil  )
   angleChanged.send_int(@ang)
end

def paintEvent ev
   eraseAll # This is necessary for rubyQt
   str = "Angle = #{@ang}"
   drawText(200,100,str)
end

end
