=begin
/****************************************************************************
** $Id: main.cpp,v 2.6 1998/06/16 11:39:32 warwick Exp $
**
** Copyright (C) 1992-1998 Troll Tech AS.  All rights reserved.
**
** This file is part of an example program for Qt.  This example
** program may be used, distributed and modified without limitation.
**
*****************************************************************************/
=end
require "hello_lib"
=begin
/*
  The program starts here. It parses the command line and builds a message
  string to be displayed by the Hello widget.
*/
=end
    a = QApplication.new([$0] + ARGV)
    s = ""
    ARGC = ARGV.size
    for i in 1..ARGC
	s += ARGV[i]
	if ( i < ARGC - 1 )
	    s += " "
        end
    end
    if ( s.size == 0 )
	s = "Hello, World"
    end
    h = Hello.new
    h.setText(s)
    h.setCaption( "Qt says hello" )
    Qt::connect( h.clicked, a, QSLOT("quit()") )
    h.setFont( QFont.new("times",32,QFont::Bold) )		#// default font
    h.setBackgroundColor( QColor("white") )			#// default bg color
    a.setMainWidget( h )
    h.show
    a.exec

